// This is mutant program.
// Author : ysma

package crosswordsage;


import java.awt.Color;
import java.awt.GridLayout;
import java.awt.event.*;
import java.util.ArrayList;
import javax.swing.*;


public class Grid extends JPanel
{

    protected crosswordsage.Square selectedSquare;

    protected java.util.ArrayList squares;

    protected crosswordsage.Word selectedWord;

    private crosswordsage.Crossword crossword;

    private crosswordsage.Square startSquare;

    private crosswordsage.Square endSquare;

    private boolean doSelectStart = false;

    private boolean doSelectEnd = false;

    public Grid()
    {
    }

    public Grid( crosswordsage.Crossword cw )
    {
        this.crossword = cw;
        setFocusable( true );
        squares = new java.util.ArrayList();
        selectedWord = null;
        setLayout( new java.awt.GridLayout( cw.getHeight(), cw.getWidth() ) );
        addKeyListener( new crosswordsage.Grid.KListener() );
        this.setBackground( Color.WHITE );
    }

    public void print()
    {
        PrintUtilities.printComponent( this );
    }

    public void setCrossword( crosswordsage.Crossword cw )
    {
        this.crossword = cw;
        java.util.ArrayList words = cw.getWords();
        for (int k = 0; k < words.size(); k++) {
            crosswordsage.Word word = (crosswordsage.Word) words.get( k );
            if (word.getWordDirection() == Word.ACROSS) {
                for (int i = word.getX(), letterIndex = 0; ++i < word.getX() + word.getLength(); i++, letterIndex++) {
                    crosswordsage.Square s = findSquare( word.getY(), i );
                    s.setWord( word );
                    s.setLetterIndexAcross( letterIndex );
                }
            } else {
                if (word.getWordDirection() == Word.DOWN) {
                    for (int i = word.getY(), letterIndex = 0; i < word.getY() + word.getLength(); i++, letterIndex++) {
                        crosswordsage.Square s = findSquare( i, word.getX() );
                        s.setWord( word );
                        s.setLetterIndexDown( letterIndex );
                    }
                }
            }
        }
    }

    public crosswordsage.Crossword getCrossword()
    {
        return crossword;
    }

    public void Build()
    {
        for (int i = 0; i < crossword.getHeight(); i++) {
            for (int j = 0; j < crossword.getWidth(); j++) {
                crosswordsage.Square s = new crosswordsage.Square( i, j, Color.BLACK );
                s.setResetColour( Color.BLACK );
                s.addMouseListener( new crosswordsage.Grid.SquareListener() );
                squares.add( s );
                s.setFontSize( 220 / crossword.getWidth() );
                add( s );
            }
        }
    }

    public void CreateWord()
    {
        int rowStart = startSquare.getXPos();
        int colStart = startSquare.getYPos();
        int rowEnd = endSquare.getXPos();
        int colEnd = endSquare.getYPos();
        int direction = 0;
        int length = 0;
        if (rowStart == rowEnd) {
            direction = Word.ACROSS;
            length = colEnd - colStart + 1;
        } else {
            if (colStart == colEnd) {
                direction = Word.DOWN;
                length = rowEnd - rowStart + 1;
            }
        }
        crosswordsage.Word word = new crosswordsage.Word( colStart, rowStart, direction, length );
        crossword.addWord( word );
        if (direction == Word.ACROSS) {
            for (int i = colStart, letterIndex = 0; i <= colEnd; i++, letterIndex++) {
                crosswordsage.Square s = findSquare( rowStart, i );
                formatSquare( s );
                s.setWord( word );
                s.setLetterIndexAcross( letterIndex );
                if (s.getLetter() != "") {
                    word.addLetter( s.getLetter(), letterIndex );
                }
                if (s.getWordDown() != null) {
                    s.getWordDown().addLetter( s.getLetter(), s.getLetterIndexDown() );
                }
            }
        } else {
            if (direction == Word.DOWN) {
                for (int i = rowStart, letterIndex = 0; i <= rowEnd; i++, letterIndex++) {
                    crosswordsage.Square s = findSquare( i, colStart );
                    formatSquare( s );
                    s.setWord( word );
                    s.setLetterIndexDown( letterIndex );
                    if (s.getLetter() != "") {
                        word.addLetter( s.getLetter(), letterIndex );
                    }
                    if (s.getWordAcross() != null) {
                        s.getWordAcross().addLetter( s.getLetter(), s.getLetterIndexAcross() );
                    }
                }
            }
        }
    }

    public void setSelectedWord( crosswordsage.Word w )
    {
        selectedWord = w;
    }

    public void splitSelectedWord( java.lang.String format )
    {
        selectedWord.setFormat( format );
    }

    public void setClueNumbers()
    {
        int clueNumber = 1;
        boolean incrementClue = false;
        java.util.ArrayList words = crossword.getWords();
        for (int i = 0; i < words.size(); i++) {
            crosswordsage.Word wd = (crosswordsage.Word) words.get( i );
            wd.setClueIndex( 0 );
        }
        for (int i = 0; i < squares.size(); i++) {
            crosswordsage.Square s = (crosswordsage.Square) squares.get( i );
            if (!s.getIsBlank()) {
                java.util.ArrayList al = s.getWords();
                for (int j = 0; j < al.size(); j++) {
                    crosswordsage.Word w = (crosswordsage.Word) al.get( j );
                    if (w.getClueIndex() == 0) {
                        w.setClueIndex( clueNumber );
                        incrementClue = true;
                    }
                }
                if (incrementClue) {
                    clueNumber++;
                }
                incrementClue = false;
            }
        }
        repopulateWords();
    }

    private void formatSquare( crosswordsage.Square s )
    {
        s.setBackground( Color.WHITE );
        s.setResetColour( Color.WHITE );
        s.setBorder( BorderFactory.createLineBorder( Color.BLACK, 1 ) );
        s.setIsBlank( false );
    }

    public void deleteSelectedWord()
    {
        java.util.ArrayList al = crossword.getWords();
        al.remove( selectedWord );
        repopulateWords();
    }

    public java.util.ArrayList getSquares()
    {
        return squares;
    }

    public void setDoSelectStart( boolean b )
    {
        startSquare = null;
        doSelectStart = b;
    }

    public void setDoSelectEnd( boolean b )
    {
        doSelectEnd = b;
    }

    public boolean getDoSelectStart()
    {
        return doSelectStart;
    }

    public boolean getDoSelectEnd()
    {
        return doSelectEnd;
    }

    public crosswordsage.Square findSquare( int x, int y )
    {
        crosswordsage.Square s = null;
        for (int i = 0; i < squares.size(); i++) {
            crosswordsage.Square s2 = (crosswordsage.Square) squares.get( i );
            if (s2.getXPos() == x && s2.getYPos() == y) {
                s = s2;
            }
        }
        return s;
    }

    public java.lang.String getSelectedClue()
    {
        java.lang.String s = null;
        if (selectedWord != null) {
            s = selectedWord.getClue();
        }
        return s;
    }

    public java.util.ArrayList getSelectedWords()
    {
        return selectedSquare.getWords();
    }

    public crosswordsage.Word getSelectedWord()
    {
        return selectedWord;
    }

    private void blankSquares()
    {
        for (int i = 0; i < squares.size(); i++) {
            crosswordsage.Square s = (crosswordsage.Square) squares.get( i );
            s.setBackground( Color.BLACK );
            s.blank();
        }
    }

    private void dissociateSquares()
    {
        for (int i = 0; i < squares.size(); i++) {
            crosswordsage.Square s = (crosswordsage.Square) squares.get( i );
            if (s.getIsBlank()) {
                s.setNoWord();
            }
        }
    }

    public void writeClue()
    {
        java.lang.String s = JOptionPane.showInputDialog( "Please enter your clue.", selectedWord.getClue() );
        selectedWord.setClue( s );
    }

    public void hiLightSelectedWord()
    {
        if (selectedSquare != null) {
            java.util.ArrayList al = selectedSquare.getWords();
            if (al != null && al.size() > 0) {
                crosswordsage.Word w = (crosswordsage.Word) getSelectedWords().get( 0 );
                if (w.getWordDirection() == Word.ACROSS) {
                    for (int i = w.getX(); i < w.getX() + w.getLength(); i++) {
                        crosswordsage.Square s = findSquare( w.getY(), i );
                        if (s != selectedSquare) {
                            s.setBackground( Color.PINK );
                        }
                    }
                } else {
                    if (w.getWordDirection() == Word.DOWN) {
                        for (int i = w.getY(); i < w.getY() + w.getLength(); i++) {
                            crosswordsage.Square s = findSquare( i, w.getX() );
                            if (s != selectedSquare) {
                                s.setBackground( Color.PINK );
                            }
                        }
                    }
                }
            }
        }
    }

    public void repopulateWords()
    {
        blankSquares();
        java.util.ArrayList al = crossword.getWords();
        for (int i = 0; i < al.size(); i++) {
            crosswordsage.Word w = (crosswordsage.Word) al.get( i );
            java.util.ArrayList letters = w.getLetters();
            if (w.getWordDirection() == Word.ACROSS) {
                for (int j = 0; j < letters.size(); j++) {
                    crosswordsage.Square s = findSquare( w.getY(), w.getX() + j );
                    if (s.getLetter() == " " || s.getLetter() == "*" || s.getLetter() == "") {
                        java.lang.String let = (java.lang.String) letters.get( j );
                        if (let == "*") {
                            let = " ";
                        }
                        s.setLetter( let );
                    }
                    s.setBackground( Color.WHITE );
                    s.setBorder( BorderFactory.createLineBorder( Color.BLACK, 1 ) );
                    if (s.isAnyWordSelected()) {
                        s.setBackground( Color.PINK );
                        s.setResetColour( Color.PINK );
                    }
                    if (j == 0) {
                        s.setClueNumber( w.getClueIndex() );
                    }
                    if (s == selectedSquare) {
                        s.setBackground( Color.RED );
                        s.setResetColour( Color.RED );
                    }
                }
            } else {
                if (w.getWordDirection() == Word.DOWN) {
                    for (int j = 0; j < letters.size(); j++) {
                        crosswordsage.Square s = findSquare( w.getY() + j, w.getX() );
                        if (s.getLetter() == " " || s.getLetter() == "*" || s.getLetter() == "") {
                            java.lang.String let = (java.lang.String) letters.get( j );
                            if (let == "*") {
                                let = " ";
                            }
                            s.setLetter( let );
                        }
                        s.setBackground( Color.WHITE );
                        s.setBorder( BorderFactory.createLineBorder( Color.BLACK, 1 ) );
                        if (s.isAnyWordSelected()) {
                            s.setBackground( Color.PINK );
                            s.setResetColour( Color.PINK );
                        }
                        if (j == 0) {
                            s.setClueNumber( w.getClueIndex() );
                        }
                        if (s == selectedSquare) {
                            s.setBackground( Color.RED );
                            s.setResetColour( Color.RED );
                        }
                    }
                }
            }
        }
        dissociateSquares();
        validate();
    }

    private void jbInit()
        throws java.lang.Exception
    {
    }

    public void removeListeners()
    {
        for (int i = 0; i < squares.size(); i++) {
            crosswordsage.Square s = (crosswordsage.Square) squares.get( i );
            crosswordsage.Grid.SquareListener ml = (crosswordsage.Grid.SquareListener) s.getMouseListeners()[0];
            s.removeMouseListener( ml );
        }
    }

    class SquareListener implements java.awt.event.MouseListener
    {

        public void mouseClicked( java.awt.event.MouseEvent e )
        {
            if (selectedSquare != null) {
                if (selectedSquare.getIsBlank()) {
                    selectedSquare.setBackground( Color.BLACK );
                } else {
                    selectedSquare.setBackground( Color.WHITE );
                }
                if (selectedWord != null) {
                    selectedWord.setIsSelected( false );
                }
            }
            requestFocus();
            crosswordsage.Square sq = (crosswordsage.Square) e.getSource();
            selectedSquare = sq;
            if (doSelectStart) {
                sq.setBackground( Color.WHITE );
                sq.setBorder( BorderFactory.createLineBorder( Color.BLACK, 1 ) );
                sq.setIsBlank( false );
                startSquare = sq;
                startSquare.setBackground( Color.BLUE );
                startSquare.setResetColour( Color.BLUE );
                doSelectStart = false;
                doSelectEnd = true;
            } else {
                if (doSelectEnd) {
                    if (sq.getX() != startSquare.getX() && sq.getY() != startSquare.getY()) {
                        JOptionPane.showMessageDialog( null, "Words must be horizontal or vertical only" );
                    } else {
                        if (sq.getX() < startSquare.getX() || sq.getY() < startSquare.getY()) {
                            JOptionPane.showMessageDialog( null, "The last square of the word must not come before the first square of the word." );
                        } else {
                            sq.setBackground( Color.WHITE );
                            sq.setBorder( BorderFactory.createLineBorder( Color.BLACK, 1 ) );
                            sq.setIsBlank( false );
                            endSquare = sq;
                            startSquare.setBackground( Color.WHITE );
                            startSquare.setResetColour( Color.WHITE );
                            doSelectEnd = false;
                            CreateWord();
                            selectedWord = selectedSquare.getNextWord();
                            if (selectedWord != null) {
                                selectedWord.setIsSelected( true );
                            }
                            repopulateWords();
                        }
                    }
                } else {
                    selectedWord = selectedSquare.getNextWord();
                    if (selectedWord != null) {
                        selectedWord.setIsSelected( true );
                    }
                    repopulateWords();
                }
            }
        }

        public void mouseEntered( java.awt.event.MouseEvent e )
        {
            crosswordsage.Square sq = (crosswordsage.Square) e.getSource();
            if (doSelectEnd || doSelectStart) {
                sq.setResetColour( sq.getBackground() );
                sq.setBackground( new java.awt.Color( 170, 255, 175 ) );
            } else {
                sq.setResetColour( sq.getBackground() );
            }
            validate();
        }

        public void mouseExited( java.awt.event.MouseEvent e )
        {
            crosswordsage.Square sq = (crosswordsage.Square) e.getSource();
            if ((doSelectEnd || doSelectStart) && sq.equals( startSquare )) {
                sq.setBackground( Color.BLUE );
            } else {
                sq.setBackground( sq.getResetColour() );
            }
            validate();
        }

        public void mousePressed( java.awt.event.MouseEvent e )
        {
        }

        public void mouseReleased( java.awt.event.MouseEvent e )
        {
        }

    }

    class KListener implements java.awt.event.KeyListener
    {

        public void keyPressed( java.awt.event.KeyEvent e )
        {
        }

        public void keyReleased( java.awt.event.KeyEvent e )
        {
        }

        public void keyTyped( java.awt.event.KeyEvent e )
        {
            java.lang.String s = null;
            if (e.getKeyChar() == '\b') {
                s = " ";
            } else {
                s = String.valueOf( e.getKeyChar() );
            }
            selectedSquare.setLetter( s );
            java.util.ArrayList al = selectedSquare.getWords();
            for (int i = 0; i < al.size(); i++) {
                crosswordsage.Word w = (crosswordsage.Word) al.get( i );
                if (w.getWordDirection() == Word.ACROSS) {
                    w.addLetter( s, selectedSquare.getLetterIndexAcross() );
                } else {
                    if (w.getWordDirection() == Word.DOWN) {
                        w.addLetter( s, selectedSquare.getLetterIndexDown() );
                    }
                }
            }
            validate();
        }

    }

}
