// This is mutant program.
// Author : ysma

package crosswordsage;


import java.awt.event.*;
import java.util.ArrayList;
import javax.swing.*;
import java.awt.*;


public class SolverGrid extends crosswordsage.Grid
{

    public SolverGrid()
    {
    }

    public SolverGrid( crosswordsage.Crossword cw )
    {
        super( cw );
    }

    public void validate()
    {
        for (int i = 0; i < squares.size(); i++) {
            crosswordsage.Square s = (crosswordsage.Square) squares.get( i );
            if (s.getWord() != null) {
                s.setBackground( Color.WHITE );
                if (s.getWordAcross() == selectedWord || s.getWordDown() == selectedWord) {
                    s.setBackground( Color.PINK );
                }
                if (s == selectedSquare) {
                    s.setBackground( Color.RED );
                }
            }
        }
        super.validate();
    }

    public void init()
    {
        for (int i = 0; i < squares.size(); i++) {
            crosswordsage.Square s = (crosswordsage.Square) squares.get( i );
            s.setLetter( " " );
            s.addMouseListener( new crosswordsage.SolverGrid.MListener() );
        }
        this.addKeyListener( new crosswordsage.SolverGrid.KListener() );
        requestFocus();
    }

    public void setSelectedWord( crosswordsage.Word w )
    {
        selectedWord = w;
        selectedSquare = findSquare( w.getY(), w.getX() );
        validate();
    }

    public void revealWord()
    {
        for (int i = 0; i < squares.size(); i++) {
            crosswordsage.Square s = (crosswordsage.Square) squares.get( i );
            crosswordsage.Word wd = s.getWordDown();
            crosswordsage.Word wa = s.getWordAcross();
            if (wd == selectedWord) {
                if (wd.getWordDirection() == Word.ACROSS) {
                    java.lang.String answerLetter = String.valueOf( wd.getWord().charAt( s.getLetterIndexAcross() ) );
                    s.setLetter( answerLetter );
                } else {
                    if (wd.getWordDirection() == Word.DOWN) {
                        java.lang.String answerLetter = String.valueOf( wd.getWord().charAt( s.getWidth() ) );
                        s.setLetter( answerLetter );
                    }
                }
            } else {
                if (wa == selectedWord) {
                    if (wa.getWordDirection() == Word.ACROSS) {
                        java.lang.String answerLetter = String.valueOf( wa.getWord().charAt( s.getLetterIndexAcross() ) );
                        s.setLetter( answerLetter );
                    } else {
                        if (wa.getWordDirection() == Word.DOWN) {
                            java.lang.String answerLetter = String.valueOf( wa.getWord().charAt( s.getLetterIndexDown() ) );
                            s.setLetter( answerLetter );
                        }
                    }
                }
            }
        }
    }

    public void checkSolution()
    {
        for (int i = 0; i < squares.size(); i++) {
            crosswordsage.Square s = (crosswordsage.Square) squares.get( i );
            s.setIsCorrect( true );
            if (s.getLetter() != " ") {
                crosswordsage.Word w = s.getWord();
                if (w != null) {
                    if (w.getWordDirection() == Word.ACROSS) {
                        java.lang.String answerLetter = String.valueOf( w.getWord().charAt( s.getLetterIndexAcross() ) );
                        if (s.getLetter().equals( answerLetter.toUpperCase() )) {
                            s.setIsCorrect( true );
                        } else {
                            s.setIsCorrect( false );
                        }
                    } else {
                        if (w.getWordDirection() == Word.DOWN) {
                            java.lang.String answerLetter = String.valueOf( w.getWord().charAt( s.getLetterIndexDown() ) );
                            if (s.getLetter().equals( answerLetter.toUpperCase() )) {
                                s.setIsCorrect( true );
                            } else {
                                s.setIsCorrect( false );
                            }
                        }
                    }
                }
            }
            s.validate();
            s.repaint();
        }
        validate();
    }

    public crosswordsage.Square getNextSquare()
    {
        if (selectedWord.getWordDirection() == Word.ACROSS) {
            crosswordsage.Square s = findSquare( selectedSquare.getXPos(), selectedSquare.getYPos() + 1 );
            if (s != null && s.getWord() != null) {
                return s;
            }
        } else {
            if (selectedWord.getWordDirection() == Word.DOWN) {
                crosswordsage.Square s = findSquare( selectedSquare.getXPos() + 1, selectedSquare.getYPos() );
                if (s != null && s.getWord() != null) {
                    return s;
                }
            }
        }
        return selectedSquare;
    }

    class MListener implements java.awt.event.MouseListener
    {

        public void mouseClicked( java.awt.event.MouseEvent e )
        {
            selectedSquare = (crosswordsage.Square) e.getSource();
            selectedWord = selectedSquare.getNextWord();
            requestFocus();
            validate();
        }

        public void mouseEntered( java.awt.event.MouseEvent e )
        {
        }

        public void mouseExited( java.awt.event.MouseEvent e )
        {
        }

        public void mousePressed( java.awt.event.MouseEvent e )
        {
        }

        public void mouseReleased( java.awt.event.MouseEvent e )
        {
        }

    }

    class KListener implements java.awt.event.KeyListener
    {

        public void keyPressed( java.awt.event.KeyEvent e )
        {
        }

        public void keyReleased( java.awt.event.KeyEvent e )
        {
        }

        public void keyTyped( java.awt.event.KeyEvent e )
        {
            java.lang.String s = null;
            if (e.getKeyChar() == '\b') {
                s = " ";
            } else {
                s = String.valueOf( e.getKeyChar() );
            }
            selectedSquare.setLetter( s );
            selectedSquare = getNextSquare();
            validate();
        }

    }

}
