// This is mutant program.
// Author : ysma

package crosswordsage;


import java.awt.*;
import java.awt.event.*;
import java.util.ArrayList;
import javax.swing.*;
import javax.swing.border.Border;


public class CrosswordSolver extends JPanel
{

    private static int MARGIN_GAP = 8;

    private java.util.ArrayList clues;

    private crosswordsage.SolverGrid grid;

    private javax.swing.Box vertBox;

    private javax.swing.Box topBox;

    private javax.swing.Box boxButtons;

    private crosswordsage.Crossword cw;

    private javax.swing.JList jList1 = new javax.swing.JList();

    private javax.swing.JScrollPane jScrollPane1 = new javax.swing.JScrollPane();

    private javax.swing.JButton btnCheckSolution = new javax.swing.JButton();

    private javax.swing.border.Border brdThinGrey = BorderFactory.createLineBorder( Color.gray, 1 );

    private javax.swing.border.Border brdMedBlack = BorderFactory.createLineBorder( Color.BLACK, 2 );

    private javax.swing.JTextPane clueTextPane = new javax.swing.JTextPane();

    javax.swing.JButton btnRevealWord = new javax.swing.JButton();

    public CrosswordSolver( crosswordsage.Crossword cw )
    {
        this.setLayout( new java.awt.BorderLayout() );
        this.cw = cw;
        grid = new crosswordsage.SolverGrid( cw );
        DisplayGrid();
        grid.setCrossword( cw );
        grid.repopulateWords();
        grid.removeListeners();
        grid.removeKeyListener( grid.getKeyListeners()[0] );
        grid.init();
        sortClueList();
        validate();
        try {
            jbInit();
        } catch ( java.lang.Exception ex ) {
            ex.printStackTrace();
        }
        AddListeners();
        compileClues();
        jList1.setListData( clues.toArray() );
    }

    private void compileClues()
    {
        java.util.ArrayList words = grid.getCrossword().getWords();
        clues = new java.util.ArrayList();
        int index1 = 0;
        boolean keepLooping = true;
        while (keepLooping) {
            keepLooping = false;
            for (int i = 1; i < words.size(); i++) {
                crosswordsage.Word w1 = (crosswordsage.Word) words.get( i - 1 );
                crosswordsage.Word w2 = (crosswordsage.Word) words.get( i );
                if (w2.getClueIndex() < w1.getClueIndex()) {
                    words.remove( w2 );
                    words.add( index1, w2 );
                    keepLooping = true;
                }
            }
        }
        java.util.ArrayList downClues = new java.util.ArrayList();
        java.util.ArrayList acrossClues = new java.util.ArrayList();
        for (int i = 0; ++i < words.size(); i++) {
            crosswordsage.Word w = (crosswordsage.Word) words.get( i );
            java.lang.String format = null;
            if (w.getFormat() != null) {
                format = w.getFormat();
            } else {
                format = String.valueOf( w.getLength() );
            }
            java.lang.String strClue = w.getClue() + " (" + format + ")";
            crosswordsage.Clue c = new crosswordsage.Clue( strClue );
            c.setWord( w );
            if (w.getWordDirection() == Word.DOWN) {
                downClues.add( c );
            } else {
                if (w.getWordDirection() == Word.ACROSS) {
                    acrossClues.add( c );
                }
            }
        }
        crosswordsage.Clue ac = new crosswordsage.Clue( "ACROSS: " );
        ac.makeHeader();
        crosswordsage.Clue dc = new crosswordsage.Clue( "DOWN: " );
        dc.makeHeader();
        acrossClues.add( 0, ac );
        downClues.add( 0, dc );
        crosswordsage.Clue gapClue = new crosswordsage.Clue( " " );
        gapClue.makeHeader();
        downClues.add( 0, gapClue );
        clues.addAll( acrossClues );
        clues.addAll( downClues );
    }

    private void sortClueList()
    {
        java.util.ArrayList words = grid.getCrossword().getWords();
        int index1 = 0;
        int index2 = 1;
        boolean keepLooping = true;
        while (keepLooping) {
            keepLooping = false;
            for (int i = 1; i < words.size(); i++) {
                crosswordsage.Word w1 = (crosswordsage.Word) words.get( i - 1 );
                crosswordsage.Word w2 = (crosswordsage.Word) words.get( i );
                if (w2.getClueIndex() < w1.getClueIndex()) {
                    words.remove( w2 );
                    words.add( index1, w2 );
                    keepLooping = true;
                }
            }
        }
    }

    private void AddListeners()
    {
        btnCheckSolution.addActionListener( new crosswordsage.CrosswordSolver.CListener() );
        jList1.addMouseListener( new crosswordsage.CrosswordSolver.ListListener() );
        java.util.ArrayList squares = grid.getSquares();
        for (int i = 0; i < squares.size(); i++) {
            crosswordsage.Square s = (crosswordsage.Square) squares.get( i );
            s.addMouseListener( new crosswordsage.CrosswordSolver.SquareListener() );
        }
    }

    public void DisplayGrid()
    {
        grid.Build();
        add( grid, BorderLayout.CENTER );
    }

    public void checkSolution()
    {
        grid.checkSolution();
    }

    private void revealWord()
    {
        grid.revealWord();
    }

    private void jbInit()
        throws java.lang.Exception
    {
        vertBox = Box.createVerticalBox();
        topBox = Box.createHorizontalBox();
        boxButtons = Box.createHorizontalBox();
        topBox = Box.createHorizontalBox();
        boxButtons = Box.createHorizontalBox();
        boxButtons.setBackground( new java.awt.Color( 199, 223, 236 ) );
        btnCheckSolution.setBorder( brdThinGrey );
        btnCheckSolution.setMaximumSize( new java.awt.Dimension( 131, 27 ) );
        btnCheckSolution.setPreferredSize( new java.awt.Dimension( 131, 27 ) );
        btnCheckSolution.setText( "Check Solution" );
        btnRevealWord.setBorder( brdThinGrey );
        btnRevealWord.setMaximumSize( new java.awt.Dimension( 160, 27 ) );
        btnRevealWord.setPreferredSize( new java.awt.Dimension( 160, 27 ) );
        grid.setMinimumSize( new java.awt.Dimension( 500, 500 ) );
        grid.setPreferredSize( new java.awt.Dimension( 500, 500 ) );
        grid.setMaximumSize( new java.awt.Dimension( 500, 500 ) );
        jList1.setMaximumSize( new java.awt.Dimension( 2000, 2000 ) );
        jList1.setMinimumSize( new java.awt.Dimension( 2, 17 ) );
        jList1.setPreferredSize( new java.awt.Dimension( 332, 2000 ) );
        jList1.setToolTipText( "" );
        jList1.setActionMap( null );
        jScrollPane1.setAutoscrolls( true );
        jScrollPane1.setMaximumSize( new java.awt.Dimension( 32767, 32767 ) );
        jScrollPane1.setPreferredSize( new java.awt.Dimension( 100, 200 ) );
        this.setBackground( new java.awt.Color( 174, 190, 212 ) );
        clueTextPane.setBorder( brdMedBlack );
        clueTextPane.setEditable( false );
        btnRevealWord.setText( "Reveal Selected Word" );
        boxButtons.add( Box.createHorizontalStrut( MARGIN_GAP ) );
        boxButtons.add( btnRevealWord );
        boxButtons.add( Box.createHorizontalStrut( MARGIN_GAP ) );
        boxButtons.add( btnCheckSolution );
        boxButtons.add( Box.createHorizontalStrut( MARGIN_GAP ) );
        topBox.add( Box.createHorizontalStrut( MARGIN_GAP ) );
        topBox.add( grid );
        topBox.add( Box.createHorizontalStrut( MARGIN_GAP ) );
        topBox.add( jScrollPane1 );
        topBox.add( Box.createHorizontalStrut( MARGIN_GAP ) );
        jScrollPane1.getViewport().add( jList1 );
        vertBox.add( Box.createVerticalStrut( MARGIN_GAP ) );
        vertBox.add( topBox );
        vertBox.add( Box.createVerticalStrut( MARGIN_GAP ) );
        vertBox.add( Box.createVerticalStrut( MARGIN_GAP ) );
        vertBox.add( boxButtons );
        vertBox.add( Box.createVerticalStrut( MARGIN_GAP ) );
        add( vertBox, BorderLayout.CENTER );
        grid.addMouseListener( new crosswordsage.CrosswordSolver.ListListener() );
        btnRevealWord.addActionListener( new crosswordsage.CrosswordSolver.CListener() );
    }

    class CListener implements java.awt.event.ActionListener
    {

        public void actionPerformed( java.awt.event.ActionEvent e )
        {
            if (e.getSource() == btnCheckSolution) {
                checkSolution();
            } else {
                if (e.getSource() == btnRevealWord) {
                    revealWord();
                }
            }
        }

    }

    class SquareListener implements java.awt.event.MouseListener
    {

        public void mouseClicked( java.awt.event.MouseEvent e )
        {
            java.lang.String s = grid.getSelectedClue();
            if (s != null) {
                clueTextPane.setText( s );
            }
            for (int i = 0; i < clues.size(); i++) {
                crosswordsage.Clue c = (crosswordsage.Clue) clues.get( i );
                if (grid.getSelectedClue() == c.getClue()) {
                    jList1.setSelectedValue( c, true );
                }
            }
        }

        public void mouseEntered( java.awt.event.MouseEvent e )
        {
        }

        public void mouseExited( java.awt.event.MouseEvent e )
        {
        }

        public void mousePressed( java.awt.event.MouseEvent e )
        {
        }

        public void mouseReleased( java.awt.event.MouseEvent e )
        {
        }

    }

    class ListListener implements java.awt.event.MouseListener
    {

        public void mouseClicked( java.awt.event.MouseEvent e )
        {
            crosswordsage.Clue c = (crosswordsage.Clue) jList1.getSelectedValue();
            crosswordsage.Word w = c.getWord();
            grid.setSelectedWord( w );
        }

        public void mouseEntered( java.awt.event.MouseEvent e )
        {
        }

        public void mouseExited( java.awt.event.MouseEvent e )
        {
        }

        public void mousePressed( java.awt.event.MouseEvent e )
        {
        }

        public void mouseReleased( java.awt.event.MouseEvent e )
        {
        }

    }

}
