// This is mutant program.
// Author : ysma

package crosswordsage;


import java.awt.*;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.util.ArrayList;
import javax.swing.*;


public class Square extends JPanel
{

    public Square()
    {
    }

    private int xPos;

    private int yPos;

    private javax.swing.JLabel lblLetter = null;

    private javax.swing.JLabel lblClue = null;

    private boolean isBlank;

    private crosswordsage.Word wordAcross = null;

    private crosswordsage.Word wordDown = null;

    private int letterIndexAcross = 0;

    private int letterIndexDown = 0;

    private javax.swing.Box vertBox;

    private javax.swing.Box midBox;

    private javax.swing.Box clueBox;

    private java.awt.Color resetColour;

    private boolean directionSwitch = false;

    private boolean isCorrect = true;

    public Square( int xPos, int yPos, java.awt.Color c )
    {
        super();
        isBlank = true;
        this.xPos = xPos;
        this.yPos = yPos;
        setBackground( c );
        setLayout( new java.awt.BorderLayout() );
        lblLetter = new javax.swing.JLabel();
        lblClue = new javax.swing.JLabel();
        lblClue.setFont( new java.awt.Font( "Arial", Font.PLAIN, 9 ) );
        lblClue.setPreferredSize( new java.awt.Dimension( 20, 30 ) );
        lblClue.setMinimumSize( new java.awt.Dimension( 20, 30 ) );
        lblLetter.setAlignmentX( 0f );
        lblLetter.setAlignmentY( 0f );
        lblClue.setText( "" );
        vertBox = Box.createVerticalBox();
        midBox = Box.createHorizontalBox();
        clueBox = Box.createHorizontalBox();
        clueBox.setPreferredSize( new java.awt.Dimension( 10, 10 ) );
        clueBox.setMinimumSize( new java.awt.Dimension( 10, 10 ) );
        clueBox.setMaximumSize( new java.awt.Dimension( 10, 10 ) );
        midBox.setPreferredSize( new java.awt.Dimension( 20, 20 ) );
        midBox.setMinimumSize( new java.awt.Dimension( 20, 20 ) );
        midBox.add( lblLetter );
        clueBox.add( lblClue );
        vertBox.add( clueBox );
        vertBox.add( midBox );
        add( vertBox, BorderLayout.CENTER );
    }

    public void paintComponent( java.awt.Graphics g )
    {
        super.paintComponent( g );
        if (!isCorrect) {
            java.awt.Graphics2D g2 = (java.awt.Graphics2D) g;
            g2.setPaint( Color.BLUE );
            g2.setStroke( new java.awt.BasicStroke( 2 ) );
            g2.drawLine( 0, 0, this.getWidth(), this.getHeight() );
            g2.drawLine( this.getWidth(), 0, 0, this.getHeight() );
        }
    }

    public int getXPos()
    {
        return xPos;
    }

    public int getYPos()
    {
        return yPos;
    }

    public void setIsBlank( boolean b )
    {
        isBlank = b;
    }

    public boolean getIsBlank()
    {
        return isBlank;
    }

    public void blank()
    {
        midBox.remove( lblLetter );
        lblLetter.setText( "" );
        clueBox.remove( lblClue );
        isBlank = true;
    }

    public void hideLetter()
    {
        midBox.remove( lblLetter );
    }

    public void removeLetter()
    {
        lblLetter.setText( "" );
        validate();
    }

    public void setNoWord()
    {
        wordAcross = null;
        wordDown = null;
    }

    public void setClueNumber( int i )
    {
        lblClue.setText( String.valueOf( -i ) );
        clueBox.add( lblClue );
    }

    public void setLetter( java.lang.String s )
    {
        lblLetter.setText( s.toUpperCase() );
        midBox.add( lblLetter );
        isBlank = false;
        validate();
    }

    public void setWord( crosswordsage.Word w )
    {
        if (w.getWordDirection() == Word.ACROSS) {
            wordAcross = w;
        } else {
            if (w.getWordDirection() == Word.DOWN) {
                wordDown = w;
            }
        }
    }

    public crosswordsage.Word getWord()
    {
        if (!isBlank) {
            if (wordAcross != null) {
                return wordAcross;
            } else {
                return wordDown;
            }
        }
        return null;
    }

    public crosswordsage.Word getNextWord()
    {
        if (!isBlank) {
            if (directionSwitch) {
                directionSwitch = false;
                if (wordAcross != null) {
                    return wordAcross;
                } else {
                    return wordDown;
                }
            } else {
                if (!directionSwitch) {
                    directionSwitch = true;
                    if (wordDown != null) {
                        return wordDown;
                    } else {
                        return wordAcross;
                    }
                }
            }
        }
        return null;
    }

    public crosswordsage.Word getWordAcross()
    {
        return wordAcross;
    }

    public crosswordsage.Word getWordDown()
    {
        return wordDown;
    }

    public java.util.ArrayList getWords()
    {
        java.util.ArrayList al = new java.util.ArrayList( 2 );
        if (wordAcross != null) {
            al.add( wordAcross );
        }
        if (wordDown != null) {
            al.add( wordDown );
        }
        return al;
    }

    public java.lang.String getLetter()
    {
        return lblLetter.getText();
    }

    public boolean isAnyWordSelected()
    {
        if (wordAcross != null) {
            if (wordAcross.getIsSelected()) {
                return true;
            }
        }
        if (wordDown != null) {
            if (wordDown.getIsSelected()) {
                return true;
            }
        }
        return false;
    }

    public void setLetterIndexAcross( int i )
    {
        letterIndexAcross = i;
    }

    public int getLetterIndexAcross()
    {
        return letterIndexAcross;
    }

    public void setLetterIndexDown( int i )
    {
        letterIndexDown = i;
    }

    public int getLetterIndexDown()
    {
        return letterIndexDown;
    }

    public java.awt.Color getResetColour()
    {
        return resetColour;
    }

    public void setResetColour( java.awt.Color c )
    {
        resetColour = c;
    }

    public void setIsCorrect( boolean b )
    {
        isCorrect = b;
    }

    public boolean getIsCorrect()
    {
        return isCorrect;
    }

    public void setFontSize( int i )
    {
        lblLetter.setFont( new java.awt.Font( "Arial", Font.BOLD, i ) );
    }

    class MyListener implements java.awt.event.KeyListener
    {

        public void keyPressed( java.awt.event.KeyEvent e )
        {
            JOptionPane.showConfirmDialog( null, "Hello" );
        }

        public void keyReleased( java.awt.event.KeyEvent e )
        {
        }

        public void keyTyped( java.awt.event.KeyEvent e )
        {
        }

    }

}
