// This is mutant program.
// Author : ysma

package crosswordsage;


import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.ArrayList;
import javax.swing.*;
import javax.swing.border.Border;


public class CrosswordCompiler extends JPanel
{

    private static int MARGIN_GAP = 8;

    private crosswordsage.Grid grid;

    private javax.swing.Box vertBox;

    private javax.swing.Box topBox;

    private javax.swing.Box clueBox;

    private javax.swing.Box boxButtons;

    private crosswordsage.Crossword cw;

    private javax.swing.JList jList1 = new javax.swing.JList();

    private javax.swing.JScrollPane jScrollPane1 = new javax.swing.JScrollPane();

    private javax.swing.JButton btnAddWord = new javax.swing.JButton();

    private javax.swing.JButton btnDeleteWord = new javax.swing.JButton();

    private javax.swing.JButton btnGetClue = new javax.swing.JButton();

    private javax.swing.JButton btnSuggestWords = new javax.swing.JButton();

    private javax.swing.JButton btnSetNumbers = new javax.swing.JButton();

    private javax.swing.JButton btnWriteClue = new javax.swing.JButton();

    private javax.swing.border.Border brdThinGrey = BorderFactory.createLineBorder( Color.gray, 1 );

    private javax.swing.border.Border brdMedBlack = BorderFactory.createLineBorder( Color.BLACK, 2 );

    private javax.swing.JTextPane clueTextPane = new javax.swing.JTextPane();

    private java.lang.StringBuffer acrossClues;

    private java.lang.StringBuffer downClues;

    private boolean doSaveCheck = false;

    public CrosswordCompiler( int width, int height )
    {
        acrossClues = new java.lang.StringBuffer();
        downClues = new java.lang.StringBuffer();
        cw = new crosswordsage.Crossword( width, height );
        grid = new crosswordsage.Grid( cw );
        this.setLayout( new java.awt.BorderLayout() );
        DisplayGrid();
        try {
            jbInit();
        } catch ( java.lang.Exception ex ) {
            ex.printStackTrace();
        }
        AddListeners();
    }

    public CrosswordCompiler()
    {
    }

    public void publishCrossword()
    {
        grid.getCrossword().setIsEditable( false );
    }

    public void loadCrossword( javax.swing.JFrame jf )
    {
        java.io.File ioDir = new java.io.File( "input_files" );
        System.out.println( "JFileChooser tries " + ioDir.getAbsolutePath() );
        javax.swing.JFileChooser chooser = new javax.swing.JFileChooser( ioDir );
        System.out.println( "JFileChooser gets " + chooser.getCurrentDirectory() );
        chooser.showOpenDialog( jf );
        java.io.File f = chooser.getSelectedFile();
        java.io.ObjectInputStream ois = null;
        try {
            ois = new java.io.ObjectInputStream( new java.io.FileInputStream( f ) );
            acrossClues = new java.lang.StringBuffer();
            downClues = new java.lang.StringBuffer();
            cw = (crosswordsage.Crossword) ois.readObject();
            if (cw.getIsEditable() == true) {
                grid = new crosswordsage.Grid( cw );
                this.setLayout( new java.awt.BorderLayout() );
                DisplayGrid();
                try {
                    jbInit();
                } catch ( java.lang.Exception ex ) {
                    ex.printStackTrace();
                }
                AddListeners();
                grid.setCrossword( cw );
                grid.repopulateWords();
                validate();
            } else {
                JOptionPane.showMessageDialog( null, "This crossword has been published and can't be edited" );
            }
            ois.close();
        } catch ( java.lang.Exception e ) {
            System.out.print( e.getStackTrace() );
        }
    }

    public void saveCrossword( javax.swing.JFrame jf )
    {
        java.io.File ioDir = new java.io.File( "input_files" );
        System.out.println( "JFileChooser tries " + ioDir.getAbsolutePath() );
        javax.swing.JFileChooser chooser = new javax.swing.JFileChooser( ioDir );
        System.out.println( "JFileChooser gets " + chooser.getCurrentDirectory() );
        chooser.showSaveDialog( jf );
        java.io.File f = chooser.getSelectedFile();
        if (!f.getAbsolutePath().endsWith( ".cws" )) {
            f.renameTo( new java.io.File( f.getAbsolutePath() + ".cws" ) );
        }
        java.io.ObjectOutputStream oos = null;
        try {
            oos = new java.io.ObjectOutputStream( new java.io.FileOutputStream( f ) );
            oos.writeObject( grid.getCrossword() );
            oos.close();
            doSaveCheck = false;
        } catch ( java.lang.Exception e ) {
            System.out.print( e.getStackTrace() );
        }
    }

    public void print()
    {
        java.lang.String title = JOptionPane.showInputDialog( null, "Enter a title for the crossword:" );
        crosswordsage.CrosswordPage cp = new crosswordsage.CrosswordPage();
        compileClues();
        cp.setCrossword( grid.getCrossword() );
        cp.setTitle( title );
        cp.setAcrossClues( acrossClues.toString() );
        cp.setDownClues( downClues.toString() );
        cp.show();
        PrintUtilities.printComponent( cp );
    }

    public boolean getDoSaveCheck()
    {
        return doSaveCheck;
    }

    public void setDoSaveCheck( boolean b )
    {
        doSaveCheck = b;
    }

    private void compileClues()
    {
        java.util.ArrayList words = grid.getCrossword().getWords();
        int index1 = 0;
        int index2 = 1;
        boolean keepLooping = true;
        while (keepLooping) {
            keepLooping = false;
            for (int i = 1; i < words.size(); i++) {
                crosswordsage.Word w1 = (crosswordsage.Word) words.get( i - 1 );
                crosswordsage.Word w2 = (crosswordsage.Word) words.get( i );
                if (w2.getClueIndex() < w1.getClueIndex()) {
                    words.remove( w2 );
                    words.add( index1, w2 );
                    keepLooping = true;
                }
            }
        }
        acrossClues = new java.lang.StringBuffer();
        downClues = new java.lang.StringBuffer();
        acrossClues.append( "ACROSS: \n" );
        downClues.append( "DOWN: \n" );
        for (int i = 0; i < words.size(); i++) {
            crosswordsage.Word w = (crosswordsage.Word) words.get( i );
            java.lang.String format = null;
            if (w.getFormat() != null) {
                format = w.getFormat();
            } else {
                format = String.valueOf( w.getLength() );
            }
            if (w.getWordDirection() == Word.DOWN) {
                downClues.append( w.getClueIndex() + ". " );
                downClues.append( w.getClue() + " (" + format + ")\n" );
            } else {
                if (w.getWordDirection() == Word.ACROSS) {
                    acrossClues.append( w.getClueIndex() + ". " );
                    acrossClues.append( w.getClue() + " (" + format + ")\n" );
                }
            }
        }
    }

    public void validate()
    {
        doSaveCheck = true;
        super.validate();
    }

    private void AddListeners()
    {
        btnAddWord.addActionListener( new crosswordsage.CrosswordCompiler.CListener() );
        btnDeleteWord.addActionListener( new crosswordsage.CrosswordCompiler.CListener() );
        btnSuggestWords.addActionListener( new crosswordsage.CrosswordCompiler.CListener() );
        jList1.addMouseListener( new crosswordsage.CrosswordCompiler.ListListener() );
        btnSetNumbers.addActionListener( new crosswordsage.CrosswordCompiler.CListener() );
        btnWriteClue.addActionListener( new crosswordsage.CrosswordCompiler.CListener() );
        btnGetClue.addActionListener( new crosswordsage.CrosswordCompiler.CListener() );
        java.util.ArrayList squares = grid.getSquares();
        for (int i = 0; i < squares.size(); i++) {
            crosswordsage.Square s = (crosswordsage.Square) squares.get( i );
            s.addMouseListener( new crosswordsage.CrosswordCompiler.SquareListener() );
        }
    }

    public void splitSelectedWord( java.lang.String format )
    {
        grid.splitSelectedWord( format );
    }

    private void deleteWord()
    {
        grid.deleteSelectedWord();
        doSaveCheck = true;
    }

    public void DisplayGrid()
    {
        grid.Build();
        add( grid, BorderLayout.CENTER );
    }

    private void jbInit()
        throws java.lang.Exception
    {
        vertBox = Box.createVerticalBox();
        topBox = Box.createHorizontalBox();
        clueBox = Box.createHorizontalBox();
        boxButtons = Box.createHorizontalBox();
        topBox = Box.createHorizontalBox();
        boxButtons = Box.createHorizontalBox();
        boxButtons.setBackground( new java.awt.Color( 199, 223, 236 ) );
        btnAddWord.setBorder( brdThinGrey );
        btnAddWord.setMaximumSize( new java.awt.Dimension( 100, 27 ) );
        btnAddWord.setPreferredSize( new java.awt.Dimension( 100, 27 ) );
        btnAddWord.setText( "Add Word" );
        btnGetClue.setBorder( brdThinGrey );
        btnGetClue.setMaximumSize( new java.awt.Dimension( 100, 27 ) );
        btnGetClue.setPreferredSize( new java.awt.Dimension( 100, 27 ) );
        btnGetClue.setText( "Get Clue" );
        btnDeleteWord.setBorder( brdThinGrey );
        btnDeleteWord.setMaximumSize( new java.awt.Dimension( 131, 27 ) );
        btnDeleteWord.setPreferredSize( new java.awt.Dimension( 131, 27 ) );
        btnDeleteWord.setText( "Delete Selected Word" );
        grid.setMinimumSize( new java.awt.Dimension( 500, 500 ) );
        grid.setPreferredSize( new java.awt.Dimension( 500, 500 ) );
        grid.setMaximumSize( new java.awt.Dimension( 500, 500 ) );
        jList1.setMaximumSize( new java.awt.Dimension( 2147483647, 2147483647 ) );
        jList1.setMinimumSize( new java.awt.Dimension( 2, 17 ) );
        jList1.setPreferredSize( new java.awt.Dimension( 332, 300000 ) );
        jList1.setToolTipText( "" );
        jList1.setActionMap( null );
        jScrollPane1.setFocusCycleRoot( true );
        jScrollPane1.setMaximumSize( new java.awt.Dimension( 32767, 32767 ) );
        jScrollPane1.setPreferredSize( new java.awt.Dimension( 100, 200 ) );
        btnSuggestWords.setBorder( brdThinGrey );
        btnSuggestWords.setMaximumSize( new java.awt.Dimension( 103, 27 ) );
        btnSuggestWords.setPreferredSize( new java.awt.Dimension( 103, 27 ) );
        btnSuggestWords.setText( "Suggest Word" );
        this.setBackground( new java.awt.Color( 174, 190, 212 ) );
        btnSetNumbers.setBorder( brdThinGrey );
        btnSetNumbers.setMaximumSize( new java.awt.Dimension( 131, 27 ) );
        btnSetNumbers.setPreferredSize( new java.awt.Dimension( 131, 27 ) );
        btnSetNumbers.setToolTipText( "" );
        btnSetNumbers.setText( "Set Clue Numbers" );
        btnWriteClue.setBorder( brdThinGrey );
        btnWriteClue.setMaximumSize( new java.awt.Dimension( 100, 27 ) );
        btnWriteClue.setPreferredSize( new java.awt.Dimension( 100, 27 ) );
        btnWriteClue.setText( "Write Clue" );
        clueTextPane.setBorder( brdMedBlack );
        clueTextPane.setEditable( false );
        clueBox.add( Box.createHorizontalStrut( MARGIN_GAP ) );
        clueBox.add( clueTextPane );
        clueBox.add( Box.createHorizontalStrut( MARGIN_GAP ) );
        boxButtons.add( Box.createHorizontalStrut( MARGIN_GAP ) );
        boxButtons.add( btnAddWord );
        boxButtons.add( Box.createHorizontalStrut( MARGIN_GAP ) );
        boxButtons.add( btnSuggestWords );
        boxButtons.add( Box.createHorizontalStrut( MARGIN_GAP ) );
        boxButtons.add( btnSetNumbers );
        boxButtons.add( Box.createHorizontalStrut( MARGIN_GAP ) );
        boxButtons.add( btnWriteClue );
        boxButtons.add( Box.createHorizontalStrut( MARGIN_GAP ) );
        boxButtons.add( btnGetClue );
        boxButtons.add( Box.createHorizontalStrut( MARGIN_GAP ) );
        boxButtons.add( btnDeleteWord );
        boxButtons.add( Box.createHorizontalStrut( MARGIN_GAP ) );
        topBox.add( Box.createHorizontalStrut( MARGIN_GAP ) );
        topBox.add( grid );
        topBox.add( Box.createHorizontalStrut( MARGIN_GAP ) );
        topBox.add( jScrollPane1 );
        topBox.add( Box.createHorizontalStrut( MARGIN_GAP ) );
        jScrollPane1.getViewport().add( jList1 );
        vertBox.add( Box.createVerticalStrut( MARGIN_GAP ) );
        vertBox.add( topBox );
        vertBox.add( Box.createVerticalStrut( MARGIN_GAP ) );
        vertBox.add( clueBox );
        vertBox.add( Box.createVerticalStrut( MARGIN_GAP ) );
        vertBox.add( boxButtons );
        vertBox.add( Box.createVerticalStrut( MARGIN_GAP ) );
        add( vertBox, BorderLayout.CENTER );
        grid.addMouseListener( new crosswordsage.CrosswordCompiler.ListListener() );
    }

    class CListener implements java.awt.event.ActionListener
    {

        public void actionPerformed( java.awt.event.ActionEvent e )
        {
            if (e.getActionCommand() == "Add Word") {
                grid.setDoSelectStart( true );
            } else {
                if (e.getActionCommand() == btnDeleteWord.getActionCommand()) {
                    deleteWord();
                } else {
                    if (e.getSource().equals( btnSuggestWords )) {
                        crosswordsage.Word w = grid.getSelectedWord();
                        java.util.ArrayList al = Utilities.getMatches( w.getWord() );
                        jList1.setListData( al.toArray() );
                        jList1.setSelectedIndex( 0 );
                        jScrollPane1.getVerticalScrollBar().setValue( 0 );
                    } else {
                        if (e.getSource().equals( btnSetNumbers )) {
                            grid.setClueNumbers();
                        } else {
                            if (e.getSource().equals( btnWriteClue )) {
                                grid.writeClue();
                            } else {
                                if (e.getSource().equals( btnGetClue )) {
                                    clueTextPane.setText( grid.getSelectedClue() );
                                    validate();
                                }
                            }
                        }
                    }
                }
            }
        }

    }

    class SquareListener implements java.awt.event.MouseListener
    {

        public void mouseClicked( java.awt.event.MouseEvent e )
        {
            java.lang.String s = grid.getSelectedClue();
            if (s != null) {
                clueTextPane.setText( s );
            }
        }

        public void mouseEntered( java.awt.event.MouseEvent e )
        {
        }

        public void mouseExited( java.awt.event.MouseEvent e )
        {
        }

        public void mousePressed( java.awt.event.MouseEvent e )
        {
        }

        public void mouseReleased( java.awt.event.MouseEvent e )
        {
        }

    }

    class ListListener implements java.awt.event.MouseListener
    {

        public void mouseClicked( java.awt.event.MouseEvent e )
        {
            if (e.getClickCount() == 2) {
                java.lang.String s = (java.lang.String) jList1.getSelectedValue();
                crosswordsage.Word w = grid.getSelectedWord();
                w.setWord( s );
                grid.repopulateWords();
                if (w.getWordDirection() == Word.ACROSS) {
                    for (int i = w.getX(); i < w.getX() + w.getLength(); i++) {
                        crosswordsage.Square sq = grid.findSquare( w.getY(), i );
                        if (sq.getWordDown() != null) {
                            sq.getWordDown().addLetter( sq.getLetter(), sq.getLetterIndexDown() );
                        }
                    }
                }
                if (w.getWordDirection() == Word.DOWN) {
                    for (int i = w.getY(); i < w.getY() + w.getLength(); i++) {
                        crosswordsage.Square sq = grid.findSquare( i, w.getX() );
                        if (sq.getWordAcross() != null) {
                            sq.getWordAcross().addLetter( sq.getLetter(), sq.getLetterIndexAcross() );
                        }
                    }
                }
            }
        }

        public void mouseEntered( java.awt.event.MouseEvent e )
        {
        }

        public void mouseExited( java.awt.event.MouseEvent e )
        {
        }

        public void mousePressed( java.awt.event.MouseEvent e )
        {
        }

        public void mouseReleased( java.awt.event.MouseEvent e )
        {
        }

    }

}
